(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("@musical-patterns/id"), require("@musical-patterns/material"), require("@musical-patterns/utilities"), require("@musical-patterns/spec"));
	else if(typeof define === 'function' && define.amd)
		define(["@musical-patterns/id", "@musical-patterns/material", "@musical-patterns/utilities", "@musical-patterns/spec"], factory);
	else {
		var a = typeof exports === 'object' ? factory(require("@musical-patterns/id"), require("@musical-patterns/material"), require("@musical-patterns/utilities"), require("@musical-patterns/spec")) : factory(root["@musical-patterns/id"], root["@musical-patterns/material"], root["@musical-patterns/utilities"], root["@musical-patterns/spec"]);
		for(var i in a) (typeof exports === 'object' ? exports : root)[i] = a[i];
	}
})(this, (__WEBPACK_EXTERNAL_MODULE__824__, __WEBPACK_EXTERNAL_MODULE__735__, __WEBPACK_EXTERNAL_MODULE__999__, __WEBPACK_EXTERNAL_MODULE__918__) => {
return /******/ (() => { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ 377:
/***/ ((module) => {

// Module
var code = "<div class=\"row\"> <div class=\"middle\"> <p> <i> This pattern demonstrates rhythmic circularity by fading out subsets of notes while increasing tempo to evolve the result through reorderings of its notes. </i> </p> <h3> Kernel Cycles </h3> <p> Start with a <b>kernel</b>, and make a cycle of kernels from it. </p> <p> A kernel is the principal input of Hafuhafu. It's a short, repeating melody / ostinato / rhythm / contour / whatever. </p> <p> Each next kernel is the previous one, just with every other note removed. They have the same total notes though, because you keep playing it over and over, so as long as the kernel length is odd, all elements are preserved, so now they are simply in a new order. </p> <p> For example a kernel <b>[1,2,3,4,5]</b> would become <b>[2,4,1,3,5]</b> because if you look at a sequence of <b>[1,2,3,4,5]</b> repeating: </p> <p> <b>...1,2,3,4,5,1,2,3,4,5,1,2,3,4,5,1,2,3,4,5...</b> </p> <p> and now take every other note: </p> <p> <b>...2,4,1,3,5,2,4,1,3,5,2,4,1,3,5,2,4,1,3,5...</b> </p> <p> you can see we have a new repeating pattern. Same elements, different order. </p> <p> Now, if we simply dropped every other note, the notes in the new pattern would last twice as long, so the music would seem to go half as fast. However, if we gradually increase the tempo to offset this impact, doubling it by the time we have faded out the departing notes, then we arrive at a place very similar to where we started. </p> <p> We could repeat this process indefinitely. <b>[2,4,1,3,5]</b> in turn becomes <b>[4,3,2,1,5]</b> which in turn becomes <b>[3,1,4,2,5]</b> which in turn returns to<b>[1,2,3,4,5]</b>. That's a kernel cycle. </p> <h3> Multiple </h3> <p> You don't always have to take just every other note. If you take every third note instead, that's sieve of 3. </p> <h3> Iteration </h3> <p> Each time a kernel has evolved into the next kernel, an iteration has completed. </p> <h3> Layer </h3> <p> Each iteration usually has several layers at different speeds, or pitches, or volumes. Each layer usually spans multiple iterations, changing speed, pitch, or volume across them. Once you go down to a single layer, the effect is lost, whether in Droste or Zeno mode. </p> <h3> Multiple Fractal </h3> <p> As the layer count increases, the sieve layers on top of itself. Some notes have only been sieved once, others twice, still others thrice. The more you've been sieved, the more gone you are. </p> <h3> Mode </h3> <p> Two modes: Droste and Zeno. Two different popular conceptions of infinite process. </p> <p> In Droste mode, you are barreling through a tunnel of kernels within kernels. The previous one disappears around your periphery; the destination is infinitesimal in the distance. Layers fade in from nothing, have their day in the sun, then fade back out to nothing. Each iteration's inactive layer is silent. It stands in the place for all the layers yet to come, still too far away and quiet to hear. </p> <p> In Zeno mode, you asymptotically approach a destination, but will never reach it. Half of the notes keep dying away, but half always still remain. Each iteration's inactive layer is at full gain. It stands in the place of all the layers yet to come, still to far away for us to know which ones are soonest to die next. </p> <p> Droste seems to need an additional layer to sound as dense as Zeno, and that's because it's inactive layer is silent where Zeno's is at full gain. By inactive layer I mean the one which is stable / unchanging in pitch, gain, and/or duration. </p> <h3> Progress </h3> <p> Progress gets measured in a few different ways, but all of them are normalized to a scalar between 0 and 1: </p> <p> - <b>Element</b>: A flat ratio of how many elements you are through the iteration to the total elements of the iteration, without respect to how long the notes are. <br> - <b>Duration</b>: Taking into account the duration of the notes (so if the pattern is slowing down, your duration progress will be ahead of the element progress at first before they catch up and tie at the end of each iteration). <br> - <b>Layer</b>: If a layer spans 3 iterations, then it would be at layer progress 1/3 by the end of the first, 2/3 by the end of the second, and 3/3 by the end of the third. </p> <p> Each of these progresses are helpful for calculating different things throughout the process. </p> <h3> Reverse </h3> <p> By default Hafuhafu speeds up and fades out, but you can also slow down and fade in! </p> </div> <div class=\"right\"></div> </div> ";
// Exports
module.exports = code;

/***/ }),

/***/ 824:
/***/ ((module) => {

"use strict";
module.exports = __WEBPACK_EXTERNAL_MODULE__824__;

/***/ }),

/***/ 735:
/***/ ((module) => {

"use strict";
module.exports = __WEBPACK_EXTERNAL_MODULE__735__;

/***/ }),

/***/ 918:
/***/ ((module) => {

"use strict";
module.exports = __WEBPACK_EXTERNAL_MODULE__918__;

/***/ }),

/***/ 999:
/***/ ((module) => {

"use strict";
module.exports = __WEBPACK_EXTERNAL_MODULE__999__;

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be in strict mode.
(() => {
"use strict";
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  "computeHafuhafuNotes": () => (/* reexport */ computeNotes),
  "pattern": () => (/* reexport */ pattern),
  "patterns": () => (/* reexport */ patterns)
});

// EXTERNAL MODULE: external "@musical-patterns/id"
var id_ = __webpack_require__(824);
// EXTERNAL MODULE: external "@musical-patterns/material"
var material_ = __webpack_require__(735);
// EXTERNAL MODULE: external "@musical-patterns/utilities"
var utilities_ = __webpack_require__(999);
;// CONCATENATED MODULE: ./src/material/features.ts
var __read = (undefined && undefined.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};


var computeNote = function (_a) {
    var _b = __read(_a, 5), pitch = _b[0], value = _b[1], intensity = _b[2], envelope = _b[3], scale = _b[4];
    if (pitch === utilities_.as.number(material_.STANDARD_PITCH_INDEX_INDICATING_REST)) {
        return {
            intensity: {
                scalar: material_.SILENT,
            },
            value: {
                scalar: utilities_.as.Scalar(value),
            },
        };
    }
    return {
        envelope: {
            scalar: utilities_.as.Scalar(envelope),
        },
        intensity: {
            scalar: utilities_.as.Scalar(intensity),
        },
        pitch: {
            index: utilities_.as.Ordinal(pitch),
            scalar: utilities_.as.Scalar(scale),
        },
        value: {
            scalar: utilities_.as.Scalar(value),
        },
    };
};


;// CONCATENATED MODULE: ./src/material/custom/cycle/nextKernel.ts

var computeNextKernel = function (_a) {
    var totalIndices = _a.totalIndices, previousKernel = _a.previousKernel, reverse = _a.reverse, sieve = _a.sieve;
    var kernelLength = (0,utilities_.computeLength)(previousKernel);
    if (reverse) {
        var nextKernel_1 = utilities_.as.Block([]);
        var terminalKernel_1 = utilities_.use.Cardinal(utilities_.as.Cycle(previousKernel), (0,utilities_.insteadOf)((0,utilities_.negative)(totalIndices)));
        (0,utilities_.range)(kernelLength)
            .map(utilities_.as.Ordinal)
            .forEach(function (terminalKernelIndex) {
            var nextKernelIndex = utilities_.use.Remaindee(utilities_.use.Transition(utilities_.use.Multiple(terminalKernelIndex, (0,utilities_.insteadOf)(sieve)), utilities_.as.Transition(utilities_.as.number(utilities_.use.Cardinal(sieve, utilities_.DECREMENT)))), utilities_.as.Remaindee(utilities_.as.number(kernelLength)));
            (0,utilities_.arraySet)(nextKernel_1, nextKernelIndex, utilities_.use.Ordinal(terminalKernel_1, terminalKernelIndex));
        });
        return nextKernel_1;
    }
    return utilities_.as.Block((0,utilities_.range)(kernelLength)
        .map(utilities_.as.Ordinal)
        .map(function (index) {
        var nextIndex = utilities_.use.Transition(utilities_.use.Multiple(index, (0,utilities_.insteadOf)(sieve)), utilities_.as.Transition(utilities_.as.number(totalIndices)));
        return utilities_.use.Ordinal(utilities_.as.Cycle(previousKernel), nextIndex);
    }));
};


// EXTERNAL MODULE: external "@musical-patterns/spec"
var spec_ = __webpack_require__(918);
;// CONCATENATED MODULE: ./src/spec/types.ts
var ExistenceStyle;
(function (ExistenceStyle) {
    ExistenceStyle["FADE"] = "FADE";
    ExistenceStyle["RANDOM_DROP"] = "RANDOM_DROP";
})(ExistenceStyle || (ExistenceStyle = {}));
var HafuhafuMode;
(function (HafuhafuMode) {
    HafuhafuMode["DROSTE"] = "DROSTE";
    HafuhafuMode["ZENO"] = "ZENO";
})(HafuhafuMode || (HafuhafuMode = {}));
var HafuhafuSpec;
(function (HafuhafuSpec) {
    HafuhafuSpec["SOURCE_KERNEL"] = "sourceKernel";
    HafuhafuSpec["SIEVE"] = "sieve";
    HafuhafuSpec["MODE"] = "mode";
    HafuhafuSpec["PITCH_STEP"] = "pitchStep";
    HafuhafuSpec["REVERSE"] = "reverse";
    HafuhafuSpec["EXISTENCE_STYLE"] = "existenceStyle";
    HafuhafuSpec["SIEVE_FRACTAL_REPETITIONS"] = "sieveFractalRepetitions";
    HafuhafuSpec["LAYER_COUNT"] = "layerCount";
    HafuhafuSpec["STRETCH_PITCH"] = "stretchPitch";
})(HafuhafuSpec || (HafuhafuSpec = {}));
var HafuhafuPreset;
(function (HafuhafuPreset) {
    HafuhafuPreset["AASB_KERNELWISE"] = "AASB_KERNELWISE";
    HafuhafuPreset["AASB_SIEVEWISE"] = "AASB_SIEVEWISE";
    HafuhafuPreset["CHORTLES"] = "CHORTLES";
    HafuhafuPreset["RECURSIEVE"] = "RECURSIEVE";
    HafuhafuPreset["MONOCOT"] = "MONOCOT";
    HafuhafuPreset["POPCORN"] = "POPCORN";
    HafuhafuPreset["SCALE_SCRAMBLE"] = "SCALE_SCRAMBLE";
    HafuhafuPreset["SHOW_TEXTURE"] = "SHOW_TEXTURE";
    HafuhafuPreset["THREE_PHASER"] = "THREE_PHASER";
    HafuhafuPreset["CATERPILLAR"] = "CATERPILLAR";
    HafuhafuPreset["SIEVELIZATION_III"] = "SIEVELIZATION_III";
})(HafuhafuPreset || (HafuhafuPreset = {}));


;// CONCATENATED MODULE: ./src/spec/constraints.ts
var _a, _b;


var optionedConstraints = (_a = {},
    _a[HafuhafuSpec.EXISTENCE_STYLE] = (0,spec_.computeBasicOptionedConstraintFromEnum)(ExistenceStyle, { required: true }),
    _a[HafuhafuSpec.MODE] = (0,spec_.computeBasicOptionedConstraintFromEnum)(HafuhafuMode, { required: true }),
    _a);
var rangedConstraints = (_b = {},
    _b[HafuhafuSpec.SIEVE_FRACTAL_REPETITIONS] = {
        integer: true,
        min: 1,
        required: true,
    },
    _b[HafuhafuSpec.SOURCE_KERNEL] = {
        integer: true,
        min: -1,
        required: true,
    },
    _b[HafuhafuSpec.SIEVE] = {
        integer: true,
        min: 2,
        required: true,
    },
    _b[HafuhafuSpec.LAYER_COUNT] = {
        integer: true,
        min: 1,
        required: true,
    },
    _b);


;// CONCATENATED MODULE: ./src/spec/orders.ts

var specsOrder = [
    HafuhafuSpec.MODE,
    HafuhafuSpec.SOURCE_KERNEL,
    HafuhafuSpec.SIEVE,
    HafuhafuSpec.LAYER_COUNT,
    HafuhafuSpec.SIEVE_FRACTAL_REPETITIONS,
    HafuhafuSpec.EXISTENCE_STYLE,
    HafuhafuSpec.STRETCH_PITCH,
    HafuhafuSpec.REVERSE,
    HafuhafuSpec.PITCH_STEP,
];
var presetsOrder = [
    HafuhafuPreset.THREE_PHASER,
    HafuhafuPreset.SCALE_SCRAMBLE,
    HafuhafuPreset.POPCORN,
    HafuhafuPreset.MONOCOT,
    HafuhafuPreset.AASB_KERNELWISE,
    HafuhafuPreset.AASB_SIEVEWISE,
    HafuhafuPreset.CHORTLES,
    HafuhafuPreset.CATERPILLAR,
    HafuhafuPreset.SHOW_TEXTURE,
    HafuhafuPreset.RECURSIEVE,
    HafuhafuPreset.SIEVELIZATION_III,
];


;// CONCATENATED MODULE: ./src/spec/configurations.ts
var __assign = (undefined && undefined.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var configurations_a;






var configurations = __assign(__assign({}, spec_.standardConfigurations), (configurations_a = {}, configurations_a[HafuhafuSpec.EXISTENCE_STYLE] = {
    constraint: optionedConstraints[HafuhafuSpec.EXISTENCE_STYLE],
    inputType: spec_.InputType.OPTIONED,
    order: specsOrder.indexOf(HafuhafuSpec.EXISTENCE_STYLE),
}, configurations_a[HafuhafuSpec.MODE] = {
    constraint: optionedConstraints[HafuhafuSpec.MODE],
    inputType: spec_.InputType.OPTIONED,
    order: specsOrder.indexOf(HafuhafuSpec.MODE),
}, configurations_a[HafuhafuSpec.SIEVE_FRACTAL_REPETITIONS] = {
    constraint: rangedConstraints[HafuhafuSpec.SIEVE_FRACTAL_REPETITIONS],
    description: "over the course of each iteration, each layer gradually transforms so that it seamlessly seems to become the layer one index off in the next iteration; for layers to accomplish this, the iterations must be in multiples of sieves, though that number of repetitions is arbitrary, simply determining how long it takes for an iteration to complete",
    formattedName: 'Multiple Repetitions',
    hideInput: spec_.RangedInputType.RANGE,
    inputType: spec_.InputType.RANGED,
    order: specsOrder.indexOf(HafuhafuSpec.SIEVE_FRACTAL_REPETITIONS),
}, configurations_a[HafuhafuSpec.SOURCE_KERNEL] = {
    arrayedConstraint: {
        minLength: 1,
        required: true,
    },
    arrayedNewFieldInitialValue: utilities_.as.number(material_.STANDARD_PITCH_INDEX_INDICATING_REST),
    constraint: rangedConstraints[HafuhafuSpec.SOURCE_KERNEL],
    description: 'a pattern of pitches to cycle (use -1 for a rest)',
    hideInput: spec_.RangedInputType.RANGE,
    inputType: spec_.InputType.RANGED,
    isArrayed: true,
    order: specsOrder.indexOf(HafuhafuSpec.SOURCE_KERNEL),
}, configurations_a[HafuhafuSpec.PITCH_STEP] = {
    constraint: {
        required: true,
    },
    description: 'the pitch resolution you write your melody in',
    inputType: spec_.InputType.RANGED,
    order: specsOrder.indexOf(HafuhafuSpec.PITCH_STEP),
}, configurations_a[HafuhafuSpec.REVERSE] = {
    description: 'the pattern infinitely slows down instead of infinitely speeding up',
    inputType: spec_.InputType.TOGGLED,
    order: specsOrder.indexOf(HafuhafuSpec.REVERSE),
}, configurations_a[HafuhafuSpec.SIEVE] = {
    constraint: rangedConstraints[HafuhafuSpec.SIEVE],
    description: 'span many notes to drop as you transform from one kernel into the next',
    hideInput: spec_.RangedInputType.RANGE,
    inputType: spec_.InputType.RANGED,
    order: specsOrder.indexOf(HafuhafuSpec.SIEVE),
}, configurations_a[HafuhafuSpec.LAYER_COUNT] = {
    constraint: rangedConstraints[HafuhafuSpec.LAYER_COUNT],
    description: "how many layers of speeds / intensities / pitches to have present simultaneously; essentially fractalizes the sieve",
    formattedName: 'Layers',
    hideInput: spec_.RangedInputType.RANGE,
    inputType: spec_.InputType.RANGED,
    order: specsOrder.indexOf(HafuhafuSpec.LAYER_COUNT),
}, configurations_a[HafuhafuSpec.STRETCH_PITCH] = {
    description: 'whether or not a pitch stretch proportional to value is applied, differentiating layers',
    inputType: spec_.InputType.TOGGLED,
    order: specsOrder.indexOf(HafuhafuSpec.STRETCH_PITCH),
}, configurations_a));


;// CONCATENATED MODULE: ./src/spec/constants.ts
// tslint:disable no-magic-numbers max-file-line-count


var HAFUHAFU_INITIAL_HZ_PHYSICALIZATION = utilities_.musicalAs.Tone(100);
var HAFUHAFU_INITIAL_MS_PHYSICALIZATION = utilities_.musicalAs.Duration(350);
var HAFUHAFU_INITIAL_KERNEL = utilities_.as.Block([0, 12, 0, 0, 12]);
var HAFUHAFU_INITIAL_MODE = HafuhafuMode.ZENO;
var HAFUHAFU_INITIAL_EXISTENCE_STYLE = ExistenceStyle.FADE;
var HAFUHAFU_INITIAL_SIEVE_FRACTAL_REPETITIONS = utilities_.as.Multiple(40);
var HAFUHAFU_INITIAL_PITCH_STEP = utilities_.SEMITONE;
var HAFUHAFU_INITIAL_REVERSE = false;
var HAFUHAFU_INITIAL_SIEVE = utilities_.as.Multiple(2);
var HAFUHAFU_INITIAL_LAYER_COUNT = utilities_.as.Cardinal(2);
var HAFUHAFU_INITIAL_STRETCH_PITCH = false;
var POPCORN_PRESET_MS_PHYSICALIZATION = utilities_.musicalAs.Duration(225);
var POPCORN_PRESET_HZ_PHYSICALIZATION = utilities_.SCIENTIFIC_PITCHES[utilities_.ScientificPitchNoteName.B][utilities_.ScientificPitchOctaveNumber._3];
var POPCORN_PRESET_KERNEL = utilities_.as.Block([12, 10, 12, 7, 3, 7, 0, -1]);
var POPCORN_PRESET_SIEVE = utilities_.as.Multiple(3);
var POPCORN_PRESET_SIEVE_FRACTAL_REPETITIONS = utilities_.as.Multiple(64);
var AASB_SIEVEWISE_PRESET_SIEVE = utilities_.as.Multiple(6);
var MONOCOT_PRESET_KERNEL = utilities_.as.Block([1]);
var MONOCOT_PRESET_SIEVE = utilities_.as.Multiple(5);
var MONOCOT_PRESET_SIEVE_FRACTAL_REPETITIONS = utilities_.as.Multiple(8);
var SCALE_SCRAMBLE_PRESET_MS_PHYSICALIZATION = utilities_.musicalAs.Duration(343);
var SCALE_SCRAMBLE_PRESET_HZ_PHYSICALIZATION = utilities_.musicalAs.Tone(77);
var SCALE_SCRAMBLE_PRESET_KERNEL = utilities_.as.Block([0, 1, 2, 3, 4, 5, 6]);
var SCALE_SCRAMBLE_PRESET_PITCH_STEP = utilities_.as.Logarithm(1.25992104989);
var SCALE_SCRAMBLE_PRESET_SIEVE_FRACTAL_REPETITIONS = utilities_.as.Multiple(49);
var SCALE_SCRAMBLE_PRESET_SIEVE = utilities_.as.Multiple(3);
var AASB_KERNELWISE_PRESET_KERNEL = utilities_.as.Block([0, 0, 0, 12, 0, 12, 12]);
var AASB_KERNELWISE_PRESET_SIEVE_FRACTAL_REPETITIONS = utilities_.as.Multiple(56);
var THREE_PHASER_PRESET_KERNEL = utilities_.as.Block([0, 0, 12, 0, 0, 12, 12]);
var THREE_PHASER_PRESET_SIEVE_FRACTAL_REPETITIONS = utilities_.as.Multiple(28);
var RECURSIEVE_PRESET_KERNEL = utilities_.as.Block([0, 3, 4, 7, 9]);
var RECURSIEVE_PRESET_LAYER_COUNT = utilities_.as.Cardinal(6);
var RECURSIEVE_PRESET_SIEVE_FRACTAL_REPETITIONS = utilities_.as.Multiple(32);
var RECURSIEVE_PRESET_MS_PHYSICALIZATION = utilities_.musicalAs.Duration(150);
var RECURSIEVE_PRESET_HZ_PHYSICALIZATION = utilities_.musicalAs.Tone(175);
var SHOW_TEXTURE_PRESET_KERNEL = utilities_.as.Block([0]);
var SHOW_TEXTURE_LAYER_COUNT = utilities_.as.Cardinal(4);
var SHOW_TEXTURE_SIEVE_FRACTAL_REPETITIONS = utilities_.as.Multiple(4);
var SHOW_TEXTURE_PRESET_MS_PHYSICALIZATION = utilities_.musicalAs.Duration(200);
var SHOW_TEXTURE_PRESET_HZ_PHYSICALIZATION = utilities_.musicalAs.Tone(200);
var CHORTLES_PRESET_LAYER_COUNT = utilities_.as.Cardinal(3);
var CHORTLES_PRESET_MS_PHYSICALIZATION = utilities_.musicalAs.Duration(250);
var CHORTLES_PRESET_KERNEL = utilities_.as.Block([0, 3, 8, 1, 7]);
var CHORTLES_PRESET_HZ_PHYSICALIZATION = utilities_.SCIENTIFIC_PITCHES[utilities_.ScientificPitchNoteName.C][utilities_.ScientificPitchOctaveNumber._4];
var CATERPILLAR_PRESET_LAYER_COUNT = utilities_.as.Cardinal(3);
var CATERPILLAR_PRESET_SIEVE_FRACTAL_REPETITIONS = utilities_.as.Multiple(80);
var CATERPILLAR_PRESET_KERNEL = utilities_.as.Block([0, -1, 0, 0, -1]);
var CATERPILLAR_PRESET_MS_PHYSICALIZATION = utilities_.musicalAs.Duration(250);
var CATERPILLAR_PRESET_HZ_PHYSICALIZATION = utilities_.musicalAs.Tone(150);
var SIEVELIZATION_III_PRESET_MS_PHYSICALIZATION = utilities_.musicalAs.Duration(250);
var SIEVELIZATION_III_PRESET_PITCH_STEP = utilities_.as.Logarithm(utilities_.SQUARE_ROOT_OF_THREE);
var SIEVELIZATION_III_PRESET_KERNEL = utilities_.as.Block([1, 0]);
var SIEVELIZATION_III_PRESET_LAYER_COUNT = utilities_.as.Cardinal(4);
var SIEVELIZATION_III_PRESET_SIEVE_FRACTAL_REPETITIONS = utilities_.as.Multiple(3);
var SIEVELIZATION_III_PRESET_SIEVE = utilities_.as.Multiple(3);


;// CONCATENATED MODULE: ./src/spec/initials.ts
var initials_assign = (undefined && undefined.__assign) || function () {
    initials_assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return initials_assign.apply(this, arguments);
};
var initials_a;



var initialSpecs = initials_assign(initials_assign({}, spec_.standardInitialSpecs), (initials_a = {}, initials_a[spec_.StandardSpec.MS_PHYSICALIZATION] = HAFUHAFU_INITIAL_MS_PHYSICALIZATION, initials_a[spec_.StandardSpec.HZ_PHYSICALIZATION] = HAFUHAFU_INITIAL_HZ_PHYSICALIZATION, initials_a[HafuhafuSpec.EXISTENCE_STYLE] = HAFUHAFU_INITIAL_EXISTENCE_STYLE, initials_a[HafuhafuSpec.SIEVE_FRACTAL_REPETITIONS] = HAFUHAFU_INITIAL_SIEVE_FRACTAL_REPETITIONS, initials_a[HafuhafuSpec.SOURCE_KERNEL] = HAFUHAFU_INITIAL_KERNEL, initials_a[HafuhafuSpec.MODE] = HAFUHAFU_INITIAL_MODE, initials_a[HafuhafuSpec.PITCH_STEP] = HAFUHAFU_INITIAL_PITCH_STEP, initials_a[HafuhafuSpec.REVERSE] = HAFUHAFU_INITIAL_REVERSE, initials_a[HafuhafuSpec.SIEVE] = HAFUHAFU_INITIAL_SIEVE, initials_a[HafuhafuSpec.LAYER_COUNT] = HAFUHAFU_INITIAL_LAYER_COUNT, initials_a[HafuhafuSpec.STRETCH_PITCH] = HAFUHAFU_INITIAL_STRETCH_PITCH, initials_a));


;// CONCATENATED MODULE: ./src/spec/presets.ts
// tslint:disable max-file-line-count
var presets_assign = (undefined && undefined.__assign) || function () {
    presets_assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return presets_assign.apply(this, arguments);
};
var presets_a, presets_b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;





var presets = (presets_a = {},
    presets_a[HafuhafuPreset.AASB_KERNELWISE] = {
        description: 'as above so below - with a kernel which cycles directly into itself',
        order: presetsOrder.indexOf(HafuhafuPreset.AASB_KERNELWISE),
        specs: presets_assign(presets_assign({}, initialSpecs), (presets_b = {}, presets_b[HafuhafuSpec.SOURCE_KERNEL] = AASB_KERNELWISE_PRESET_KERNEL, presets_b[HafuhafuSpec.SIEVE_FRACTAL_REPETITIONS] = AASB_KERNELWISE_PRESET_SIEVE_FRACTAL_REPETITIONS, presets_b)),
    },
    presets_a[HafuhafuPreset.AASB_SIEVEWISE] = {
        description: 'as above so below - with a sieve that takes each next note in the original kernel',
        order: presetsOrder.indexOf(HafuhafuPreset.AASB_SIEVEWISE),
        specs: presets_assign(presets_assign({}, initialSpecs), (_c = {}, _c[HafuhafuSpec.SIEVE] = AASB_SIEVEWISE_PRESET_SIEVE, _c)),
    },
    presets_a[HafuhafuPreset.CHORTLES] = {
        description: 'as above so below - with a sieve that takes each next note in the original kernel',
        order: presetsOrder.indexOf(HafuhafuPreset.CHORTLES),
        specs: presets_assign(presets_assign({}, initialSpecs), (_d = {}, _d[HafuhafuSpec.LAYER_COUNT] = CHORTLES_PRESET_LAYER_COUNT, _d[HafuhafuSpec.SOURCE_KERNEL] = CHORTLES_PRESET_KERNEL, _d[spec_.StandardSpec.HZ_PHYSICALIZATION] = CHORTLES_PRESET_HZ_PHYSICALIZATION, _d[spec_.StandardSpec.MS_PHYSICALIZATION] = CHORTLES_PRESET_MS_PHYSICALIZATION, _d)),
    },
    presets_a[HafuhafuPreset.RECURSIEVE] = {
        description: 'demonstration of the droste mode',
        order: presetsOrder.indexOf(HafuhafuPreset.RECURSIEVE),
        specs: presets_assign(presets_assign({}, initialSpecs), (_e = {}, _e[HafuhafuSpec.SOURCE_KERNEL] = RECURSIEVE_PRESET_KERNEL, _e[HafuhafuSpec.MODE] = HafuhafuMode.DROSTE, _e[HafuhafuSpec.LAYER_COUNT] = RECURSIEVE_PRESET_LAYER_COUNT, _e[HafuhafuSpec.SIEVE_FRACTAL_REPETITIONS] = RECURSIEVE_PRESET_SIEVE_FRACTAL_REPETITIONS, _e[HafuhafuSpec.REVERSE] = true, _e[spec_.StandardSpec.MS_PHYSICALIZATION] = RECURSIEVE_PRESET_MS_PHYSICALIZATION, _e[spec_.StandardSpec.HZ_PHYSICALIZATION] = RECURSIEVE_PRESET_HZ_PHYSICALIZATION, _e)),
    },
    presets_a[HafuhafuPreset.MONOCOT] = {
        description: 'sieve does all the work',
        order: presetsOrder.indexOf(HafuhafuPreset.MONOCOT),
        specs: presets_assign(presets_assign({}, initialSpecs), (_f = {}, _f[HafuhafuSpec.SOURCE_KERNEL] = MONOCOT_PRESET_KERNEL, _f[HafuhafuSpec.SIEVE] = MONOCOT_PRESET_SIEVE, _f[HafuhafuSpec.SIEVE_FRACTAL_REPETITIONS] = MONOCOT_PRESET_SIEVE_FRACTAL_REPETITIONS, _f)),
    },
    presets_a[HafuhafuPreset.POPCORN] = {
        description: 'thanks to Gershon Kingsley',
        order: presetsOrder.indexOf(HafuhafuPreset.POPCORN),
        specs: presets_assign(presets_assign({}, initialSpecs), (_g = {}, _g[spec_.StandardSpec.MS_PHYSICALIZATION] = POPCORN_PRESET_MS_PHYSICALIZATION, _g[spec_.StandardSpec.HZ_PHYSICALIZATION] = POPCORN_PRESET_HZ_PHYSICALIZATION, _g[HafuhafuSpec.SOURCE_KERNEL] = POPCORN_PRESET_KERNEL, _g[HafuhafuSpec.SIEVE] = POPCORN_PRESET_SIEVE, _g[HafuhafuSpec.REVERSE] = true, _g[HafuhafuSpec.SIEVE_FRACTAL_REPETITIONS] = POPCORN_PRESET_SIEVE_FRACTAL_REPETITIONS, _g)),
    },
    presets_a[HafuhafuPreset.SCALE_SCRAMBLE] = {
        description: 'thanks to Gershon Kingsley',
        order: presetsOrder.indexOf(HafuhafuPreset.SCALE_SCRAMBLE),
        specs: presets_assign(presets_assign({}, initialSpecs), (_h = {}, _h[spec_.StandardSpec.HZ_PHYSICALIZATION] = SCALE_SCRAMBLE_PRESET_HZ_PHYSICALIZATION, _h[spec_.StandardSpec.MS_PHYSICALIZATION] = SCALE_SCRAMBLE_PRESET_MS_PHYSICALIZATION, _h[HafuhafuSpec.SOURCE_KERNEL] = SCALE_SCRAMBLE_PRESET_KERNEL, _h[HafuhafuSpec.SIEVE] = SCALE_SCRAMBLE_PRESET_SIEVE, _h[HafuhafuSpec.SIEVE_FRACTAL_REPETITIONS] = SCALE_SCRAMBLE_PRESET_SIEVE_FRACTAL_REPETITIONS, _h[HafuhafuSpec.PITCH_STEP] = SCALE_SCRAMBLE_PRESET_PITCH_STEP, _h)),
    },
    presets_a[HafuhafuPreset.SHOW_TEXTURE] = {
        description: 'minimal kernel demonstrates the shape of the sieve fractal',
        order: presetsOrder.indexOf(HafuhafuPreset.SHOW_TEXTURE),
        specs: presets_assign(presets_assign({}, initialSpecs), (_j = {}, _j[HafuhafuSpec.SOURCE_KERNEL] = SHOW_TEXTURE_PRESET_KERNEL, _j[HafuhafuSpec.MODE] = HafuhafuMode.DROSTE, _j[HafuhafuSpec.LAYER_COUNT] = SHOW_TEXTURE_LAYER_COUNT, _j[HafuhafuSpec.SIEVE_FRACTAL_REPETITIONS] = SHOW_TEXTURE_SIEVE_FRACTAL_REPETITIONS, _j[HafuhafuSpec.STRETCH_PITCH] = true, _j[spec_.StandardSpec.MS_PHYSICALIZATION] = SHOW_TEXTURE_PRESET_MS_PHYSICALIZATION, _j[spec_.StandardSpec.HZ_PHYSICALIZATION] = SHOW_TEXTURE_PRESET_HZ_PHYSICALIZATION, _j)),
    },
    presets_a[HafuhafuPreset.THREE_PHASER] = {
        description: 'kernel cycles through three versions which are not rotations of each other',
        order: presetsOrder.indexOf(HafuhafuPreset.THREE_PHASER),
        specs: presets_assign(presets_assign({}, initialSpecs), (_k = {}, _k[HafuhafuSpec.SOURCE_KERNEL] = THREE_PHASER_PRESET_KERNEL, _k[HafuhafuSpec.SIEVE_FRACTAL_REPETITIONS] = THREE_PHASER_PRESET_SIEVE_FRACTAL_REPETITIONS, _k)),
    },
    presets_a[HafuhafuPreset.CATERPILLAR] = {
        description: 'a purely rhythmic hafuhafu endeavour',
        order: presetsOrder.indexOf(HafuhafuPreset.CATERPILLAR),
        specs: presets_assign(presets_assign({}, initialSpecs), (_l = {}, _l[HafuhafuSpec.LAYER_COUNT] = CATERPILLAR_PRESET_LAYER_COUNT, _l[HafuhafuSpec.SIEVE_FRACTAL_REPETITIONS] = CATERPILLAR_PRESET_SIEVE_FRACTAL_REPETITIONS, _l[HafuhafuSpec.SOURCE_KERNEL] = CATERPILLAR_PRESET_KERNEL, _l[spec_.StandardSpec.MS_PHYSICALIZATION] = CATERPILLAR_PRESET_MS_PHYSICALIZATION, _l[spec_.StandardSpec.HZ_PHYSICALIZATION] = CATERPILLAR_PRESET_HZ_PHYSICALIZATION, _l)),
    },
    presets_a[HafuhafuPreset.SIEVELIZATION_III] = {
        description: 'a demonstration of the power of sieves greater than 2 in droste mode',
        formattedName: 'Sievelization III',
        specs: presets_assign(presets_assign({}, initialSpecs), (_m = {}, _m[spec_.StandardSpec.MS_PHYSICALIZATION] = SIEVELIZATION_III_PRESET_MS_PHYSICALIZATION, _m[HafuhafuSpec.PITCH_STEP] = SIEVELIZATION_III_PRESET_PITCH_STEP, _m[HafuhafuSpec.SOURCE_KERNEL] = SIEVELIZATION_III_PRESET_KERNEL, _m[HafuhafuSpec.MODE] = HafuhafuMode.DROSTE, _m[HafuhafuSpec.LAYER_COUNT] = SIEVELIZATION_III_PRESET_LAYER_COUNT, _m[HafuhafuSpec.SIEVE_FRACTAL_REPETITIONS] = SIEVELIZATION_III_PRESET_SIEVE_FRACTAL_REPETITIONS, _m[HafuhafuSpec.STRETCH_PITCH] = true, _m[HafuhafuSpec.SIEVE] = SIEVELIZATION_III_PRESET_SIEVE, _m)),
    },
    presets_a);


;// CONCATENATED MODULE: ./src/spec/validations.ts


var computeValidations = function (hafuhafuSpecs) {
    var _a;
    var sourceKernel = hafuhafuSpecs[HafuhafuSpec.SOURCE_KERNEL];
    var sieve = hafuhafuSpecs[HafuhafuSpec.SIEVE];
    var kernelLength = (0,utilities_.computeLength)(sourceKernel);
    if (!(0,utilities_.areCoprime)(kernelLength, sieve)) {
        var doNotIncludeTheFirstCommonFactorBecauseItIsJustOne = utilities_.as.Ordinal(1);
        var commonFactors = (0,utilities_.slice)((0,utilities_.computeCommonFactors)(kernelLength, sieve), doNotIncludeTheFirstCommonFactorBecauseItIsJustOne);
        var validationMessage_1 = "The sieve and kernel share at least one non-1 factor (".concat(String(commonFactors), ") and thus some kernel elements will not be preserved across iterations, preventing the formation of a kernel cycle.");
        return _a = {},
            _a[HafuhafuSpec.SOURCE_KERNEL] = sourceKernel.map(function () { return validationMessage_1; }),
            _a[HafuhafuSpec.SIEVE] = validationMessage_1,
            _a;
    }
    return undefined;
};


;// CONCATENATED MODULE: ./src/spec/specs.ts




var spec = {
    computeValidations: computeValidations,
    configurations: configurations,
    initialSpecs: initialSpecs,
    presets: presets,
};


;// CONCATENATED MODULE: ./src/spec/index.ts



;// CONCATENATED MODULE: ./src/material/custom/constants.ts
// tslint:disable no-magic-numbers

var DROSTE_ITERATION_REALIGNMENT_SHIFT = utilities_.as.Cardinal(1);


;// CONCATENATED MODULE: ./src/material/custom/cycle/totalIndices.ts



var computeSieveFractalLength = function (sieve, layerCount) {
    return utilities_.as.Cardinal(utilities_.as.number(utilities_.use.Power(sieve, utilities_.as.Power(utilities_.as.number(utilities_.use.Cardinal(layerCount, utilities_.DECREMENT))))));
};
var computeIterationLength = function (sieve, layerCount, sieveFractalRepetitions) {
    return utilities_.use.Multiple(computeSieveFractalLength(sieve, layerCount), sieveFractalRepetitions);
};
var computeTotalIndices = function (_a) {
    var layerCount = _a.layerCount, mode = _a.mode, sieve = _a.sieve, sieveFractalRepetitions = _a.sieveFractalRepetitions;
    return utilities_.use.Cardinal(computeIterationLength(sieve, layerCount, sieveFractalRepetitions), mode === HafuhafuMode.DROSTE ? DROSTE_ITERATION_REALIGNMENT_SHIFT : utilities_.NO_SHIFT);
};


;// CONCATENATED MODULE: ./src/material/custom/cycle/kernelCycles.ts



var computeKernelCycle = function (_a) {
    var sourceKernel = _a.sourceKernel, layerCount = _a.layerCount, mode = _a.mode, reverse = _a.reverse, sieve = _a.sieve, sieveFractalRepetitions = _a.sieveFractalRepetitions;
    var totalIndices = computeTotalIndices({ layerCount: layerCount, mode: mode, sieve: sieve, sieveFractalRepetitions: sieveFractalRepetitions });
    var kernelCycle = utilities_.as.Cycle([(0,utilities_.deepClone)(sourceKernel)]);
    var nextKernel = computeNextKernel({ previousKernel: sourceKernel, reverse: reverse, sieve: sieve, totalIndices: totalIndices });
    while (!(0,utilities_.deepEqual)(sourceKernel, nextKernel)) {
        kernelCycle.push((0,utilities_.deepClone)(nextKernel));
        nextKernel = computeNextKernel({ previousKernel: nextKernel, reverse: reverse, sieve: sieve, totalIndices: totalIndices });
    }
    return kernelCycle;
};


;// CONCATENATED MODULE: ./src/material/custom/cycle/index.ts



;// CONCATENATED MODULE: ./src/material/custom/element/envelope.ts

var computeEnvelope = function (_a) {
    var sieve = _a.sieve;
    return (0,utilities_.insteadOf)((0,utilities_.reciprocal)(sieve));
};


;// CONCATENATED MODULE: ./src/material/custom/element/constants.ts
// tslint:disable no-magic-numbers

var HALFWAY_THROUGH = utilities_.as.NormalScalar(0.5);
var DOUBLE_THE_PROGRESS_AS_A_HACK_TO_MAKE_IT_WORK_FOR_HALF_AN_ITERATION = utilities_.as.Multiple(2);
var CONSIDER_ONLY_THE_SECOND_HALF_OF_THE_PROGRESS = utilities_.as.Translation((0,utilities_.negative)(0.5));


;// CONCATENATED MODULE: ./src/material/custom/element/intensity.ts




var computeRandomDropIntensity = function (_a) {
    var fadingIntensity = _a.fadingIntensity, randomizingFunction = _a.randomizingFunction;
    return randomizingFunction() < utilities_.as.number(fadingIntensity) ?
        material_.FULL_GAIN :
        material_.SILENT;
};
var transformProgressToUseItForFirstHalf = function (elementProgress) {
    return utilities_.as.NormalScalar(utilities_.as.number(utilities_.use.Multiple(utilities_.as.Scalar(utilities_.as.number(elementProgress)), DOUBLE_THE_PROGRESS_AS_A_HACK_TO_MAKE_IT_WORK_FOR_HALF_AN_ITERATION)));
};
var transformProgressToUseItForSecondHalf = function (elementProgress) {
    return utilities_.as.NormalScalar(utilities_.as.number(utilities_.use.Multiple(utilities_.use.Translation(elementProgress, CONSIDER_ONLY_THE_SECOND_HALF_OF_THE_PROGRESS), DOUBLE_THE_PROGRESS_AS_A_HACK_TO_MAKE_IT_WORK_FOR_HALF_AN_ITERATION)));
};
var computeIntensity = function (_a) {
    var existenceStyle = _a.existenceStyle, layerProgress = _a.layerProgress, mode = _a.mode;
    var fadingIntensity = utilities_.as.Scalar(mode === HafuhafuMode.ZENO ?
        utilities_.as.number((0,utilities_.invertNormalScalar)(layerProgress)) :
        layerProgress < HALFWAY_THROUGH ?
            (0,utilities_.valueLinearlyBetweenValues)(0, 1, transformProgressToUseItForFirstHalf(layerProgress)) :
            (0,utilities_.valueLinearlyBetweenValues)(1, 0, transformProgressToUseItForSecondHalf(layerProgress)));
    return existenceStyle === ExistenceStyle.FADE ?
        fadingIntensity :
        computeRandomDropIntensity({ fadingIntensity: fadingIntensity, randomizingFunction: utilities_.random });
};


;// CONCATENATED MODULE: ./src/material/custom/element/pitch.ts


var computePitchIndex = function (_a) {
    var iterationKernel = _a.iterationKernel, iterationIndex = _a.iterationIndex;
    return utilities_.as.Ordinal(utilities_.use.Ordinal(utilities_.as.Cycle(iterationKernel), (0,utilities_.insteadOf)(iterationIndex)));
};
var computeDrostePitchScalarPower = function (activeLayerCount, layerProgress) {
    var maximumAbsolutePower = utilities_.as.Exponent(utilities_.as.number(utilities_.use.Scalar(activeLayerCount, utilities_.ONE_HALF)));
    return (0,utilities_.valueLinearlyBetweenValues)((0,utilities_.negative)(maximumAbsolutePower), maximumAbsolutePower, utilities_.as.NormalScalar(utilities_.as.number(layerProgress)));
};
var computePitchScalar = function (_a) {
    var layerCount = _a.layerCount, layerProgress = _a.layerProgress, mode = _a.mode, sieve = _a.sieve, stretchPitch = _a.stretchPitch;
    if (!stretchPitch) {
        return utilities_.MULTIPLICATIVE_IDENTITY;
    }
    var activeLayerCount = utilities_.use.Cardinal(layerCount, utilities_.ONE_FEWER);
    var layerScalar = utilities_.as.Scalar(utilities_.as.number(activeLayerCount));
    var pitchScalarPower = mode === HafuhafuMode.DROSTE ?
        computeDrostePitchScalarPower(activeLayerCount, layerProgress) :
        utilities_.as.Exponent(utilities_.as.number(utilities_.use.Scalar(layerProgress, layerScalar)));
    return utilities_.as.Scalar(utilities_.use.Exponent(utilities_.as.number(sieve), pitchScalarPower));
};


;// CONCATENATED MODULE: ./src/material/custom/element/value.ts


var computeElementProgress = function (_a) {
    var iterationIndex = _a.iterationIndex, reverse = _a.reverse, totalIndices = _a.totalIndices;
    var rawTotalIndices = utilities_.as.number(totalIndices);
    if (!reverse) {
        return utilities_.as.NormalScalar((0,utilities_.quotient)(utilities_.as.number(iterationIndex), rawTotalIndices));
    }
    var indexReassignedToChangeOwnershipOfIntervalWithNeighboringNote = utilities_.use.Remaindee(utilities_.use.Cardinal(iterationIndex, utilities_.INCREMENT), utilities_.as.Remaindee(rawTotalIndices));
    return (0,utilities_.invertNormalScalar)(utilities_.as.NormalScalar((0,utilities_.quotient)(utilities_.as.number(indexReassignedToChangeOwnershipOfIntervalWithNeighboringNote), rawTotalIndices)));
};
var computeValue = function (_a) {
    var iterationIndex = _a.iterationIndex, layerCount = _a.layerCount, mode = _a.mode, reverse = _a.reverse, sieve = _a.sieve, totalIndices = _a.totalIndices;
    var elementProgress = computeElementProgress({ iterationIndex: iterationIndex, reverse: reverse, totalIndices: totalIndices });
    return mode === HafuhafuMode.ZENO && layerCount === utilities_.as.Cardinal(1) ?
        utilities_.as.Scalar(1) :
        utilities_.as.Scalar(utilities_.use.Scalar(utilities_.use.Exponent(utilities_.as.number(sieve), utilities_.as.Exponent(utilities_.as.number((0,utilities_.invertNormalScalar)(elementProgress)))), (0,utilities_.insteadOf)((0,utilities_.reciprocal)(sieve))));
};


;// CONCATENATED MODULE: ./src/material/custom/element/elements.ts





var computeLayerProgress = function (_a) {
    var layerIndices = _a.layerIndices, iterationIndex = _a.iterationIndex, layersProgresses = _a.layersProgresses;
    var layerIndex = (0,utilities_.insteadOf)(utilities_.use.Ordinal(layerIndices, (0,utilities_.insteadOf)(iterationIndex)));
    return utilities_.use.Ordinal(utilities_.use.Ordinal(layersProgresses, (0,utilities_.insteadOf)(layerIndex)), (0,utilities_.insteadOf)(iterationIndex));
};
var computeElement = function (_a) {
    var existenceStyle = _a.existenceStyle, iterationIndex = _a.iterationIndex, iterationKernel = _a.iterationKernel, layerCount = _a.layerCount, layerIndices = _a.layerIndices, layersProgresses = _a.layersProgresses, mode = _a.mode, reverse = _a.reverse, sieve = _a.sieve, stretchPitch = _a.stretchPitch, totalIndices = _a.totalIndices;
    var layerProgress = computeLayerProgress({ iterationIndex: iterationIndex, layerIndices: layerIndices, layersProgresses: layersProgresses });
    var pitchIndex = computePitchIndex({ iterationIndex: iterationIndex, iterationKernel: iterationKernel });
    var value = computeValue({ iterationIndex: iterationIndex, layerCount: layerCount, mode: mode, reverse: reverse, sieve: sieve, totalIndices: totalIndices });
    var intensity = computeIntensity({ existenceStyle: existenceStyle, layerProgress: layerProgress, mode: mode });
    var envelope = computeEnvelope({ sieve: sieve });
    var pitchScalar = computePitchScalar({ layerCount: layerCount, layerProgress: layerProgress, mode: mode, sieve: sieve, stretchPitch: stretchPitch });
    return utilities_.as.ContourElement([
        utilities_.as.number(pitchIndex),
        utilities_.as.number(value),
        utilities_.as.number(intensity),
        utilities_.as.number(envelope),
        utilities_.as.number(pitchScalar),
    ]);
};


;// CONCATENATED MODULE: ./src/material/custom/element/index.ts



;// CONCATENATED MODULE: ./src/material/custom/layer/constants.ts
// tslint:disable no-magic-numbers

var DROSTE_SIEVE_FRACTAL_LAYER_INITIAL_INDEX_COMPUTATION_PARTIAL_POWER_SUM_SHIFT = utilities_.as.Cardinal((0,utilities_.negative)(3));


;// CONCATENATED MODULE: ./src/material/custom/layer/sieveFractals.ts



var computeLayerInitialIndex = function (sieve, layerCount, mode) {
    return mode === HafuhafuMode.DROSTE ?
        utilities_.as.Ordinal((0,utilities_.computePartialSumOfExponents)(utilities_.as.Base(utilities_.as.number(sieve)), utilities_.as.Exponent(utilities_.as.number(utilities_.use.Cardinal(layerCount, DROSTE_SIEVE_FRACTAL_LAYER_INITIAL_INDEX_COMPUTATION_PARTIAL_POWER_SUM_SHIFT))))) :
        utilities_.INITIAL;
};
var computeSieveFractal = function (sieve, layerCount, mode) {
    if (layerCount === utilities_.as.Cardinal(1)) {
        return [utilities_.INITIAL];
    }
    var lowerLayerSieveFractal = computeSieveFractal(sieve, utilities_.use.Cardinal(layerCount, utilities_.DECREMENT), mode);
    var incrementedSieveFractal = lowerLayerSieveFractal.map(function (sieveFractalElement) { return utilities_.use.Cardinal(sieveFractalElement, utilities_.NEXT); });
    var sieveFractal = (0,utilities_.repeat)(incrementedSieveFractal, utilities_.as.Cardinal(utilities_.as.number(sieve)));
    (0,utilities_.arraySet)(sieveFractal, computeLayerInitialIndex(sieve, layerCount, mode), utilities_.INITIAL);
    return sieveFractal;
};


;// CONCATENATED MODULE: ./src/material/custom/layer/indices.ts




var computeLayerIndex = function (_a) {
    var layerCount = _a.layerCount, mode = _a.mode, reverse = _a.reverse, sieve = _a.sieve, iterationIndex = _a.iterationIndex;
    var sieveFractalCycle = utilities_.as.Cycle(computeSieveFractal(sieve, layerCount, mode));
    var maybeReversedSieveFractalCycle = reverse ?
        utilities_.use.Cardinal(utilities_.as.Cycle((0,utilities_.computeReverse)(sieveFractalCycle)), mode === HafuhafuMode.DROSTE ? DROSTE_ITERATION_REALIGNMENT_SHIFT : utilities_.NO_SHIFT) :
        sieveFractalCycle;
    return utilities_.use.Ordinal(maybeReversedSieveFractalCycle, (0,utilities_.insteadOf)(iterationIndex));
};
var computeLayerIndices = function (_a) {
    var layerCount = _a.layerCount, mode = _a.mode, reverse = _a.reverse, sieve = _a.sieve, totalIndices = _a.totalIndices;
    return (0,utilities_.range)(totalIndices)
        .map(function (integer) { return utilities_.as.Ordinal(integer); })
        .map(function (iterationIndex) {
        return computeLayerIndex({ iterationIndex: iterationIndex, layerCount: layerCount, mode: mode, reverse: reverse, sieve: sieve });
    });
};


;// CONCATENATED MODULE: ./src/material/custom/layer/beginAndEnd.ts


var computeLayerBegin = function (_a) {
    var layerCount = _a.layerCount, layerIndex = _a.layerIndex, mode = _a.mode;
    if (layerCount === utilities_.as.Cardinal(1)) {
        return utilities_.as.NormalScalar(0);
    }
    var activeLayerCount = utilities_.use.Cardinal(layerCount, utilities_.DECREMENT);
    var layerStep = utilities_.as.NormalScalar(utilities_.as.number((0,utilities_.reciprocal)(activeLayerCount)));
    var baseScalarFromIndex = utilities_.as.Scalar(utilities_.as.number(mode === HafuhafuMode.DROSTE || layerIndex === (0,utilities_.insteadOf)(utilities_.INITIAL) ?
        layerIndex :
        utilities_.use.Cardinal(layerIndex, utilities_.DECREMENT)));
    return utilities_.as.NormalScalar(utilities_.as.number(utilities_.use.NormalScalar(baseScalarFromIndex, layerStep)));
};
var computeLayerEnd = function (_a) {
    var layerCount = _a.layerCount, layerIndex = _a.layerIndex, mode = _a.mode;
    return layerIndex === (0,utilities_.finalIndexFromElementsTotal)(layerCount) ?
        utilities_.as.NormalScalar(1) :
        computeLayerBegin({ layerCount: layerCount, layerIndex: utilities_.use.Cardinal(layerIndex, utilities_.INCREMENT), mode: mode });
};


;// CONCATENATED MODULE: ./src/material/custom/layer/totalValue.ts


var computeTotalValue = function (_a) {
    var layerCount = _a.layerCount, mode = _a.mode, reverse = _a.reverse, sieve = _a.sieve, totalIndices = _a.totalIndices;
    return (0,utilities_.range)(totalIndices)
        .map(function (integer) { return utilities_.as.Ordinal(integer); })
        .reduce(function (totalValue, iterationIndex) {
        return utilities_.use.Translation(totalValue, utilities_.as.Translation((0,utilities_.ofNotAs)(computeValue({
            iterationIndex: iterationIndex,
            layerCount: layerCount,
            mode: mode,
            reverse: reverse,
            sieve: sieve,
            totalIndices: totalIndices,
        }))));
    }, utilities_.as.Scalar(0));
};


;// CONCATENATED MODULE: ./src/material/custom/layer/valueProgress.ts


var computeValueProgress = function (_a) {
    var iterationIndex = _a.iterationIndex, layerCount = _a.layerCount, mode = _a.mode, reverse = _a.reverse, sieve = _a.sieve, totalValue = _a.totalValue, totalIndices = _a.totalIndices, valueProgress = _a.valueProgress;
    var value = computeValue({ iterationIndex: iterationIndex, layerCount: layerCount, mode: mode, reverse: reverse, sieve: sieve, totalIndices: totalIndices });
    var currentValueProgress = utilities_.as.NormalScalar(utilities_.as.number((0,utilities_.quotient)(value, totalValue)));
    return utilities_.as.NormalScalar(utilities_.use.Translation(utilities_.as.number(valueProgress), utilities_.as.Translation(utilities_.as.number(currentValueProgress))));
};
var computeValueProgresses = function (_a) {
    var layerCount = _a.layerCount, mode = _a.mode, reverse = _a.reverse, sieve = _a.sieve, totalValue = _a.totalValue, totalIndices = _a.totalIndices;
    var valueProgress = utilities_.as.NormalScalar(0);
    return (0,utilities_.range)(totalIndices)
        .map(function (integer) { return utilities_.as.Ordinal(integer); })
        .map(function (iterationIndex) {
        valueProgress = computeValueProgress({
            iterationIndex: iterationIndex,
            layerCount: layerCount,
            mode: mode,
            reverse: reverse,
            sieve: sieve,
            totalIndices: totalIndices,
            totalValue: totalValue,
            valueProgress: valueProgress,
        });
        return valueProgress;
    });
};


;// CONCATENATED MODULE: ./src/material/custom/layer/progress.ts




var computeLayerProgresses = function (_a) {
    var layerCount = _a.layerCount, layerIndex = _a.layerIndex, mode = _a.mode, reverse = _a.reverse, sieve = _a.sieve, totalValue = _a.totalValue, totalIndices = _a.totalIndices;
    var begin = computeLayerBegin({ layerCount: layerCount, layerIndex: layerIndex, mode: mode });
    var end = computeLayerEnd({ layerCount: layerCount, layerIndex: layerIndex, mode: mode });
    var valueProgresses = computeValueProgresses({
        layerCount: layerCount,
        mode: mode,
        reverse: reverse,
        sieve: sieve,
        totalIndices: totalIndices,
        totalValue: totalValue,
    });
    return valueProgresses.map(function (valueProgress) {
        return (0,utilities_.valueLinearlyBetweenValues)(reverse ? end : begin, reverse ? begin : end, valueProgress);
    });
};
var computeLayersProgresses = function (_a) {
    var layerCount = _a.layerCount, mode = _a.mode, reverse = _a.reverse, sieve = _a.sieve, totalIndices = _a.totalIndices;
    var totalValue = computeTotalValue({ layerCount: layerCount, mode: mode, reverse: reverse, sieve: sieve, totalIndices: totalIndices });
    return (0,utilities_.range)(layerCount)
        .map(function (integer) { return utilities_.as.Ordinal(integer); })
        .map(function (layerIndex) { return computeLayerProgresses({
        layerCount: layerCount,
        layerIndex: layerIndex,
        mode: mode,
        reverse: reverse,
        sieve: sieve,
        totalIndices: totalIndices,
        totalValue: totalValue,
    }); });
};


;// CONCATENATED MODULE: ./src/material/custom/layer/index.ts



;// CONCATENATED MODULE: ./src/material/custom/index.ts




;// CONCATENATED MODULE: ./src/material/pieces.ts


var computePiece = function (iterationKernel, specs) {
    var existenceStyle = specs.existenceStyle, layerCount = specs.layerCount, mode = specs.mode, reverse = specs.reverse, sieve = specs.sieve, sieveFractalRepetitions = specs.sieveFractalRepetitions, stretchPitch = specs.stretchPitch;
    var totalIndices = computeTotalIndices({ layerCount: layerCount, mode: mode, sieve: sieve, sieveFractalRepetitions: sieveFractalRepetitions });
    var layerIndices = computeLayerIndices({ layerCount: layerCount, mode: mode, reverse: reverse, sieve: sieve, totalIndices: totalIndices });
    var layersProgresses = computeLayersProgresses({ layerCount: layerCount, mode: mode, reverse: reverse, sieve: sieve, totalIndices: totalIndices });
    return utilities_.as.ContourPiece((0,utilities_.range)(totalIndices)
        .map(function (integer) { return utilities_.as.Ordinal(integer); })
        .map(function (iterationIndex) {
        return computeElement({
            existenceStyle: existenceStyle,
            iterationIndex: iterationIndex,
            iterationKernel: iterationKernel,
            layerCount: layerCount,
            layerIndices: layerIndices,
            layersProgresses: layersProgresses,
            mode: mode,
            reverse: reverse,
            sieve: sieve,
            stretchPitch: stretchPitch,
            totalIndices: totalIndices,
        });
    }));
};


;// CONCATENATED MODULE: ./src/material/wholes.ts



var computeWholes = function (specs) {
    var kernelCycle = computeKernelCycle(specs);
    var pieces = kernelCycle.map(function (iterationKernel) {
        return computePiece(iterationKernel, specs);
    });
    return utilities_.as.ContourWhole((0,utilities_.flatten)(pieces));
};


;// CONCATENATED MODULE: ./src/material/notes.ts


var computeNotes = function (specs) {
    return computeWholes(specs)
        .map(computeNote);
};


;// CONCATENATED MODULE: ./src/material/entities.ts


var materializeEntities = function (specs) { return [
    {
        sections: [{ notes: computeNotes(specs) }],
        timbreName: material_.TimbreNameEnum.WURLITZER,
    },
]; };


;// CONCATENATED MODULE: ./src/material/constants.ts
// tslint:disable no-magic-numbers

var ENOUGH_PITCH_SCALARS_THAT_NO_ONE_WILL_PROBABLY_EVER_NOTICE = utilities_.as.Integer(256);


;// CONCATENATED MODULE: ./src/material/scalars.ts


var computePitchScalars = function (_a) {
    var pitchStep = _a.pitchStep;
    return (0,utilities_.range)(ENOUGH_PITCH_SCALARS_THAT_NO_ONE_WILL_PROBABLY_EVER_NOTICE)
        .map(function (integer) {
        return utilities_.as.Scalar(utilities_.as.number((0,utilities_.pow)(pitchStep, utilities_.as.Power(integer))));
    });
};


;// CONCATENATED MODULE: ./src/material/scales.ts


var materializeScales = function (specs) {
    return (0,material_.materializeStandardScales)(specs, { pitchScalars: computePitchScalars(specs) });
};


;// CONCATENATED MODULE: ./src/material/materials.ts


var material = {
    materializeEntities: materializeEntities,
    materializeScales: materializeScales,
};


;// CONCATENATED MODULE: ./src/material/index.ts



;// CONCATENATED MODULE: ./src/metadata/posts.ts
var env = "production";
// tslint:disable-next-line
var post = env !== 'test' && env != 'material' ? (__webpack_require__(377)["default"]) : '';


;// CONCATENATED MODULE: ./src/metadata/metadatas.ts

var metadata = {
    description: post,
    formattedName: 'Hafuhafu',
    mostRecentPublish: "2022-10-10T19:04:38.789Z" || 0,
    musicalIdeaIllustrated: 'rhythmic circularity',
    originalPublish: '2018-09-27T07:00:00.000Z',
    version: "1.0.211" || 0,
};


;// CONCATENATED MODULE: ./src/metadata/index.ts


;// CONCATENATED MODULE: ./src/patterns.ts
var patterns_a;




var pattern = {
    id: id_.Id.HAFUHAFU,
    material: material,
    metadata: metadata,
    spec: spec,
};
var patterns = (patterns_a = {},
    patterns_a[pattern.id] = pattern,
    patterns_a);


;// CONCATENATED MODULE: ./src/index.ts



})();

/******/ 	return __webpack_exports__;
/******/ })()
;
});