import { Block, Cardinal, Duration, Frequency, Logarithm, Tone } from '@musical-patterns/utilities';
import { Layer } from '../nominals';
import { Sieve, SieveFractalRepetitions } from '../types';
import { ExistenceStyle, HafuhafuMode } from './types';
declare const HAFUHAFU_INITIAL_HZ_PHYSICALIZATION: Tone;
declare const HAFUHAFU_INITIAL_MS_PHYSICALIZATION: Duration;
declare const HAFUHAFU_INITIAL_KERNEL: Block;
declare const HAFUHAFU_INITIAL_MODE: HafuhafuMode;
declare const HAFUHAFU_INITIAL_EXISTENCE_STYLE: ExistenceStyle;
declare const HAFUHAFU_INITIAL_SIEVE_FRACTAL_REPETITIONS: SieveFractalRepetitions;
declare const HAFUHAFU_INITIAL_PITCH_STEP: Logarithm<Frequency>;
declare const HAFUHAFU_INITIAL_REVERSE: boolean;
declare const HAFUHAFU_INITIAL_SIEVE: Sieve;
declare const HAFUHAFU_INITIAL_LAYER_COUNT: Cardinal<Layer[]>;
declare const HAFUHAFU_INITIAL_STRETCH_PITCH: boolean;
declare const POPCORN_PRESET_MS_PHYSICALIZATION: Duration;
declare const POPCORN_PRESET_HZ_PHYSICALIZATION: Tone;
declare const POPCORN_PRESET_KERNEL: Block;
declare const POPCORN_PRESET_SIEVE: Sieve;
declare const POPCORN_PRESET_SIEVE_FRACTAL_REPETITIONS: SieveFractalRepetitions;
declare const AASB_SIEVEWISE_PRESET_SIEVE: Sieve;
declare const MONOCOT_PRESET_KERNEL: Block;
declare const MONOCOT_PRESET_SIEVE: Sieve;
declare const MONOCOT_PRESET_SIEVE_FRACTAL_REPETITIONS: SieveFractalRepetitions;
declare const SCALE_SCRAMBLE_PRESET_MS_PHYSICALIZATION: Duration;
declare const SCALE_SCRAMBLE_PRESET_HZ_PHYSICALIZATION: Tone;
declare const SCALE_SCRAMBLE_PRESET_KERNEL: Block;
declare const SCALE_SCRAMBLE_PRESET_PITCH_STEP: Logarithm<Frequency>;
declare const SCALE_SCRAMBLE_PRESET_SIEVE_FRACTAL_REPETITIONS: SieveFractalRepetitions;
declare const SCALE_SCRAMBLE_PRESET_SIEVE: Sieve;
declare const AASB_KERNELWISE_PRESET_KERNEL: Block;
declare const AASB_KERNELWISE_PRESET_SIEVE_FRACTAL_REPETITIONS: SieveFractalRepetitions;
declare const THREE_PHASER_PRESET_KERNEL: Block;
declare const THREE_PHASER_PRESET_SIEVE_FRACTAL_REPETITIONS: SieveFractalRepetitions;
declare const RECURSIEVE_PRESET_KERNEL: Block;
declare const RECURSIEVE_PRESET_LAYER_COUNT: Cardinal<Layer[]>;
declare const RECURSIEVE_PRESET_SIEVE_FRACTAL_REPETITIONS: SieveFractalRepetitions;
declare const RECURSIEVE_PRESET_MS_PHYSICALIZATION: Duration;
declare const RECURSIEVE_PRESET_HZ_PHYSICALIZATION: Tone;
declare const SHOW_TEXTURE_PRESET_KERNEL: Block;
declare const SHOW_TEXTURE_LAYER_COUNT: Cardinal<Layer[]>;
declare const SHOW_TEXTURE_SIEVE_FRACTAL_REPETITIONS: SieveFractalRepetitions;
declare const SHOW_TEXTURE_PRESET_MS_PHYSICALIZATION: Duration;
declare const SHOW_TEXTURE_PRESET_HZ_PHYSICALIZATION: Tone;
declare const CHORTLES_PRESET_LAYER_COUNT: Cardinal<Layer[]>;
declare const CHORTLES_PRESET_MS_PHYSICALIZATION: Duration;
declare const CHORTLES_PRESET_KERNEL: Block;
declare const CHORTLES_PRESET_HZ_PHYSICALIZATION: Tone;
declare const CATERPILLAR_PRESET_LAYER_COUNT: Cardinal<Layer[]>;
declare const CATERPILLAR_PRESET_SIEVE_FRACTAL_REPETITIONS: SieveFractalRepetitions;
declare const CATERPILLAR_PRESET_KERNEL: Block;
declare const CATERPILLAR_PRESET_MS_PHYSICALIZATION: Duration;
declare const CATERPILLAR_PRESET_HZ_PHYSICALIZATION: Tone;
declare const SIEVELIZATION_III_PRESET_MS_PHYSICALIZATION: Duration;
declare const SIEVELIZATION_III_PRESET_PITCH_STEP: Logarithm<Frequency>;
declare const SIEVELIZATION_III_PRESET_KERNEL: Block;
declare const SIEVELIZATION_III_PRESET_LAYER_COUNT: Cardinal<Layer[]>;
declare const SIEVELIZATION_III_PRESET_SIEVE_FRACTAL_REPETITIONS: SieveFractalRepetitions;
declare const SIEVELIZATION_III_PRESET_SIEVE: Sieve;
export { HAFUHAFU_INITIAL_HZ_PHYSICALIZATION, HAFUHAFU_INITIAL_MS_PHYSICALIZATION, HAFUHAFU_INITIAL_KERNEL, HAFUHAFU_INITIAL_MODE, HAFUHAFU_INITIAL_EXISTENCE_STYLE, HAFUHAFU_INITIAL_SIEVE_FRACTAL_REPETITIONS, HAFUHAFU_INITIAL_PITCH_STEP, HAFUHAFU_INITIAL_REVERSE, HAFUHAFU_INITIAL_SIEVE, HAFUHAFU_INITIAL_LAYER_COUNT, HAFUHAFU_INITIAL_STRETCH_PITCH, POPCORN_PRESET_MS_PHYSICALIZATION, POPCORN_PRESET_HZ_PHYSICALIZATION, POPCORN_PRESET_KERNEL, POPCORN_PRESET_SIEVE, AASB_SIEVEWISE_PRESET_SIEVE, MONOCOT_PRESET_KERNEL, MONOCOT_PRESET_SIEVE, SCALE_SCRAMBLE_PRESET_MS_PHYSICALIZATION, SCALE_SCRAMBLE_PRESET_HZ_PHYSICALIZATION, SCALE_SCRAMBLE_PRESET_KERNEL, SCALE_SCRAMBLE_PRESET_PITCH_STEP, SCALE_SCRAMBLE_PRESET_SIEVE, SCALE_SCRAMBLE_PRESET_SIEVE_FRACTAL_REPETITIONS, AASB_KERNELWISE_PRESET_KERNEL, THREE_PHASER_PRESET_KERNEL, THREE_PHASER_PRESET_SIEVE_FRACTAL_REPETITIONS, RECURSIEVE_PRESET_MS_PHYSICALIZATION, RECURSIEVE_PRESET_HZ_PHYSICALIZATION, RECURSIEVE_PRESET_SIEVE_FRACTAL_REPETITIONS, RECURSIEVE_PRESET_KERNEL, RECURSIEVE_PRESET_LAYER_COUNT, SHOW_TEXTURE_PRESET_KERNEL, SHOW_TEXTURE_LAYER_COUNT, SHOW_TEXTURE_SIEVE_FRACTAL_REPETITIONS, SHOW_TEXTURE_PRESET_MS_PHYSICALIZATION, SHOW_TEXTURE_PRESET_HZ_PHYSICALIZATION, CHORTLES_PRESET_LAYER_COUNT, CHORTLES_PRESET_MS_PHYSICALIZATION, CHORTLES_PRESET_HZ_PHYSICALIZATION, CHORTLES_PRESET_KERNEL, POPCORN_PRESET_SIEVE_FRACTAL_REPETITIONS, MONOCOT_PRESET_SIEVE_FRACTAL_REPETITIONS, AASB_KERNELWISE_PRESET_SIEVE_FRACTAL_REPETITIONS, CATERPILLAR_PRESET_MS_PHYSICALIZATION, CATERPILLAR_PRESET_HZ_PHYSICALIZATION, CATERPILLAR_PRESET_KERNEL, CATERPILLAR_PRESET_LAYER_COUNT, CATERPILLAR_PRESET_SIEVE_FRACTAL_REPETITIONS, SIEVELIZATION_III_PRESET_MS_PHYSICALIZATION, SIEVELIZATION_III_PRESET_PITCH_STEP, SIEVELIZATION_III_PRESET_KERNEL, SIEVELIZATION_III_PRESET_LAYER_COUNT, SIEVELIZATION_III_PRESET_SIEVE_FRACTAL_REPETITIONS, SIEVELIZATION_III_PRESET_SIEVE, };
